<?php

function image_pixelate_form($action) {
  $form['pixel'] = array(
    '#type' => 'textfield',
    '#title' => t('Block size in pixels'),
    '#default_value' => isset($action['pixel']) ? $action['pixel'] : '1',
    '#description' => t('Enter a block size in pixels i.e. 1 or 50.'),
  );
  return $form;
}

function image_pixelate_image(&$image, $data) {
  if (!imagefilter($image->resource, IMG_FILTER_PIXELATE, $data['pixel'], true)) {
    watchdog('image_pixelate', 'image_pixelate_image failed. image: %image, data: %data.', array('%path' => $image, '%data' => print_r($data, TRUE)), WATCHDOG_ERROR);
    return FALSE;
  }
  return TRUE;
}

function theme_image_pixelate($element) {
  $data = $element['#value'];
  if ($data['pixel']) {
    return check_plain($data['pixel']);
  }
  return ($data['width']) ? t('width @width', array('@width' => $data['width'])) : t('height @height', array('@height' => $data['height']));
}